import type { Container } from "../Container.js";
import type { IDelta } from "./IDelta.js";
import type { Particle } from "../Particle.js";
export type IShapeDrawData<TParticle extends Particle = Particle> = {
    context: CanvasRenderingContext2D;
    delta: IDelta;
    opacity: number;
    particle: TParticle;
    pixelRatio: number;
    radius: number;
};
export interface IShapeDrawer<TParticle extends Particle = Particle> {
    afterEffect?: (data: IShapeDrawData<TParticle>) => void;
    destroy?: (container: Container) => void;
    draw: (data: IShapeDrawData<TParticle>) => void;
    getSidesCount?: (particle: TParticle) => number;
    init?: (container: Container) => Promise<void>;
    loadShape?: (particle: TParticle) => void;
    particleInit?: (container: Container, particle: TParticle) => void;
}
