import { AnimatableColor } from "../AnimatableColor.js";
import { Collisions } from "./Collisions/Collisions.js";
import type { Container } from "../../../Core/Container.js";
import type { Engine } from "../../../Core/Engine.js";
import type { IInteractivity } from "../../Interfaces/Interactivity/IInteractivity.js";
import type { IOptionLoader } from "../../Interfaces/IOptionLoader.js";
import type { IParticlesOptions } from "../../Interfaces/Particles/IParticlesOptions.js";
import { Move } from "./Move/Move.js";
import { Opacity } from "./Opacity/Opacity.js";
import { ParticlesBounce } from "./Bounce/ParticlesBounce.js";
import type { ParticlesGroups } from "../../../Types/ParticlesGroups.js";
import { ParticlesNumber } from "./Number/ParticlesNumber.js";
import type { RecursivePartial } from "../../../Types/RecursivePartial.js";
import { Shadow } from "./Shadow.js";
import { Shape } from "./Shape/Shape.js";
import type { SingleOrMultiple } from "../../../Types/SingleOrMultiple.js";
import { Size } from "./Size/Size.js";
import { Stroke } from "./Stroke.js";
import { ZIndex } from "./ZIndex/ZIndex.js";
export declare class ParticlesOptions implements IParticlesOptions, IOptionLoader<IParticlesOptions> {
    [name: string]: unknown;
    bounce: ParticlesBounce;
    collisions: Collisions;
    color: AnimatableColor;
    groups: ParticlesGroups;
    interactivity?: RecursivePartial<IInteractivity>;
    move: Move;
    number: ParticlesNumber;
    opacity: Opacity;
    reduceDuplicates: boolean;
    shadow: Shadow;
    shape: Shape;
    size: Size;
    stroke: SingleOrMultiple<Stroke>;
    zIndex: ZIndex;
    private readonly _container;
    private readonly _engine;
    constructor(engine: Engine, container?: Container);
    load(data?: RecursivePartial<IParticlesOptions>): void;
}
